﻿<%@ Page Language="C#" CodeFile="Default.aspx.cs" Inherits="_Default" %>
<%@ Import Namespace="SeriousBit.Licensing"%>

<%
    try
    {
        //Custom HTTP Request keygen for online serials creation
        //usage example: http://yoursitename.com/this_keygen_folder?private_key=4BGT36NHARMFXMVYJQKDUW2&crc_to_id=User+Full+Name&delimit=6

        SerialsManager manager = new SerialsManager(null, null);//Ellipter does not check developer key when creating serials

        string private_key = Request.QueryString.Get("private_key");
        string id_str = Request.QueryString.Get("id");//if null then a random (128 <> 228) is created
        string crc_to_id = Request.QueryString.Get("crc_to_id");//if ID is null and crc_to_id is not null then the CRC of crc_to_id's value is used as serial ID
        string info = Request.QueryString.Get("info");
        //if is 'true' then INFO is transformed to its CRC and stored in serials info field
        string crc = Request.QueryString.Get("info_to_crc");
        string exp_day = Request.QueryString.Get("exp_day");
        string exp_month = Request.QueryString.Get("exp_month");
        string exp_year = Request.QueryString.Get("exp_year");
        string delimit = Request.QueryString.Get("delimit");


        if(private_key == null)
        {
            ArgumentError("Missing private key.");
            return;
        }

        manager.PrivateKey = private_key;
        ChecksumCalculator calc = new ChecksumCalculator();

        int id;
        if (id_str == null)
        {
            if(crc_to_id != null)
            {
               id = calc.ComputeChecksum(crc_to_id);
            }
            else
            {
                Random random = new Random(DateTime.Now.Millisecond);
                id = 128 + random.Next(100);
            }
        }
        else
        {
            id = int.Parse(id_str);
        }

        if(crc != null && crc.ToLower() == "true")
        {
            if (info != null)
            {
                info = calc.ComputeChecksum(info).ToString();
            }
        }

        string serial;

        if(exp_day != null)
        {
            DateTime expDate = new DateTime(int.Parse(exp_year), int.Parse(exp_month), int.Parse(exp_day));
            serial = manager.CreateSerial(id, expDate, info);
        }
        else
        {
            serial = manager.CreateSerial(id, info);
        }

        //delimit serial
        if (delimit != null)
        {
            int d = int.Parse(delimit);
            if (d < serial.Length - 1)
            {
                int i = 0;
                while (d*(i + 1) + i < serial.Length)
                {
                    serial = serial.Insert(d*(i + 1) + i, "-");
                    i++;
                }
            }
        }

        //return serial to caller
        Response.Write(serial);

        //send notification to developer
        SendMail("A serial has been sent from ellipter key generator",
        string.Format(
@"Serial = {0}.
Query string = {1}
Referer = {2}
User IP = {3}
User Address = {4}
User Agent = {5}", serial, Request.QueryString, Request.UrlReferrer, Request.UserHostAddress, Request.UserHostAddress, Request.UserAgent));

    }
    catch (Exception ex)
    {
        Response.Write("Error on creating serial. Please contact support.");

        //send notification to developer
        SendMail("Error in ellipter key generator", ex.ToString());
    }
%>








